/* 
   $Id: klist.c,v 1.2 2001/08/28 02:22:37 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/List.h>

#define KIGOU_START 0x2100
#define KIGOU_END   0x7e00
#define KIGOU_COLUMN    8
#define KIGOU_RAW       4
#define KIGOU_DISP_MAX  32

static Widget kigouForm, kigouCommandForm;
static Widget kigouList;
static Widget kigouRETBtn;
static int    kigouPage = 0;

char    kigou_codes[KIGOU_DISP_MAX][3];
String  kigou_list[KIGOU_DISP_MAX + 1];

static Widget jisMenuShell;
static Widget kanji1MenuShell;
static Widget jisPopShell;
static Widget jisForm;
static Widget jisNumBtns[16];
static Widget jisCodeLabel;
static Widget jisCodeBtn;
static int    currentCode = 0;

extern void NnmGetShellPos(int *x, int *y, int *width, int *height);
extern void switchToTop(void );


void NnmGetWindowPos(w, x, y, width, height)
     Widget w;
     int    *x, *y, *width, *height;
{
  Arg args[10];

  args[0].name = "x";
  args[0].value = (XtArgVal) x;
  args[1].name = "y";
  args[1].value = (XtArgVal) y;
  args[2].name = "width";
  args[2].value = (XtArgVal) width;
  args[3].name = "height";
  args[3].value = (XtArgVal) height;
  XtGetValues( w, args, 4);
}


void   kigouNextBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  i;
  char s[256];

  kigouPage += 0x20;

  if((kigouPage & 0xff) >= 0x80) kigouPage = (kigouPage & 0xff00) + 0x100;
  if((kigouPage & 0xff) <= 0x20) kigouPage = (kigouPage & 0xff00) + 0x20;

  if((KIGOU_START + kigouPage) > 0x7e60) kigouPage = 0x7e60 - KIGOU_START;

  for( i = 0; i < KIGOU_DISP_MAX; i++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + i) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + i) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];
  }
  kigou_list[i] = NULL;
  XawListChange(kigouList, kigou_list, i, 0, True);

  sprintf(s, "%04x", kigouPage + KIGOU_START);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);

}

void   kigouPrevBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  i;
  char s[256];

  kigouPage -= 0x20;

  if(kigouPage < 0x20){
    kigouPage = 0x20;
    return;
  }

  if((kigouPage & 0xff) >= 0x80 || ((kigouPage & 0xff)== 0))    
    kigouPage = (kigouPage & 0xff00) - 0xa0;
  else if((kigouPage & 0xff) < 0x20)       kigouPage = (kigouPage & 0xff00) - 0x80;

  for( i = 0; i < 0x20; i++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + i) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + i) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];
  }
  kigou_list[i] = NULL;
  XawListChange(kigouList, kigou_list, i, 0, True);

  sprintf(s, "%04x", kigouPage + KIGOU_START);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);

}

static void popdownJisMenu()
{
  XtPopdown(jisMenuShell);
  XtPopdown(kanji1MenuShell);
}

static void popdownKigou()
{
  XtPopdown(jisPopShell);
  popdownJisMenu();
}

void   kigouRETBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  popdownKigou();
  switchToTop();
}

static void	kigouListProc( Widget w, XtPointer cli, XtPointer clo )
{
  extern void setCode(char *);
  XawListReturnStruct *list_return;

  list_return = (XawListReturnStruct *) clo;
  setCode(list_return->string);
  kigouRETBtnProc(w,cli,clo);
}

void NnmSetJisCodeBtnLabel(int code)
{
  Arg        args[10];
  int        i;
  char       s[256];

  while( (code != 0) && (code < 0xfff)) code <<=4;

  sprintf(s, "%04x", code);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);
}

static void NnmSetJisCodeLabelLabel(int code)
{
  Arg        args[10];
  int        i;
  char       s[256];

  while( (code != 0) && (code < 0xfff)) code <<=4;

  sprintf(s, "%04x", code);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeLabel, args, i);
}

static void  jisNumBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  int        i, j, idx;
  char       s[256];

  idx = (int)cli;

  if( (currentCode > 0xff) && (currentCode < 0xfff) ) {
    currentCode <<= 4;
    currentCode += idx;

    s[0] = (currentCode & 0xff) | 0x80;
    s[1] = (currentCode >> 8)   | 0x80;
    s[2] = 0;

    currentCode = 0;
    NnmSetJisCodeBtnLabel(currentCode);
    NnmSetJisCodeLabelLabel(currentCode);

  }else if( (currentCode > 0xf) && (currentCode < 0xff) ) {
    currentCode <<= 4;
    currentCode += idx;

    kigouPage = ((currentCode << 4)& 0xffe0)- KIGOU_START;

    if(kigouPage < 0)
      currentCode = KIGOU_START >> 4, kigouPage = 0;
    else if(kigouPage > KIGOU_END - KIGOU_START)
      currentCode = KIGOU_END >> 4, kigouPage = KIGOU_END - KIGOU_START;

    if((kigouPage & 0xff) <= 0x20) kigouPage = (kigouPage & 0xff00) + 0x20;
    if((kigouPage & 0xff) >= 0x80) kigouPage = (kigouPage & 0xff00) + 0x120;

    for( i = j = 0; i < 0x20; i++,j++){
      kigou_codes[i][0] = ((KIGOU_START + kigouPage + j) >> 8)  | 0x80;
      kigou_codes[i][1] = ((KIGOU_START + kigouPage + j) & 0xff)| 0x80;
      kigou_codes[i][2] = '\0';
      kigou_list[i] = kigou_codes[i];
    }
    kigou_list[i] = NULL;
    XawListChange(kigouList, kigou_list, i, 0, True);

    NnmSetJisCodeBtnLabel(kigouPage + KIGOU_START);
    NnmSetJisCodeLabelLabel(currentCode);
  }else{
    currentCode <<= 4;
    currentCode += idx;
    NnmSetJisCodeBtnLabel(currentCode);
    NnmSetJisCodeLabelLabel(currentCode);
  }

}

static void  jisBSBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  currentCode >>= 4;
  NnmSetJisCodeBtnLabel(currentCode);
  NnmSetJisCodeLabelLabel(currentCode);
}

static void  kanji1CloseBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  XtPopdown(kanji1MenuShell);
}

static void  jisMenuCloseBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  XtPopdown(jisMenuShell);
  XtPopdown(kanji1MenuShell);
}

static void  jisCloseBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  XtPopdown(jisPopShell);
}

static void  kanji1BtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg args[10];
  int x, y, width, height;
  int wx, wy;

  x = 0, y = 0, width = 0, height = 0;
  wx = 0, wy = 0;

  NnmGetWindowPos(jisCodeBtn, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouCommandForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetShellPos(&x, &y, &width, &height);
  wx += x, wy += y;

  XtSetArg( args[0], XtNx, wx );
  XtSetArg( args[1], XtNy, wy );
  XtSetValues( kanji1MenuShell, args, 2 );

  XtPopup(kanji1MenuShell, XtGrabNone );
}

static void  jisMenuProc( Widget w, XtPointer cli, XtPointer clo )
{
    int l;

    currentCode = (int)cli;
    l = (currentCode & 0xf0) >> 4;
    currentCode >>= 8;
    jisNumBtnProc(w,(XtPointer)l,NULL);
}

static void	NnmCreateJISMenu( Widget top )
{
  Arg		args[10];
  int		num;
  Widget        itemBtn1,itemBtn2, itemBtn3, closeBtn,form;

  jisMenuShell = XtCreatePopupShell( "jismenu",
				      overrideShellWidgetClass,
				      top, NULL, 0 );
  form = XtCreateManagedWidget( "jismenuform", formWidgetClass,
				   jisMenuShell, NULL, 0 );


  num = 0;
  itemBtn1 = XtCreateManagedWidget( "kigou", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x2121);
  num = 0;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "num", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn2, XtNcallback, jisMenuProc, (XtPointer)0x2330);
  num = 0;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  itemBtn3 = XtCreateManagedWidget( "alpha", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn3, XtNcallback, jisMenuProc, (XtPointer)0x2341);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  itemBtn1 = XtCreateManagedWidget( "hira", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x2421);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn2 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "kata", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn2, XtNcallback, jisMenuProc, (XtPointer)0x2521);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn3 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  itemBtn3 = XtCreateManagedWidget( "greek", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn3, XtNcallback, jisMenuProc, (XtPointer)0x2621);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  itemBtn1 = XtCreateManagedWidget( "russ", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x2721);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn2 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "lines", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn2, XtNcallback, jisMenuProc, (XtPointer)0x2821);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn3 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  itemBtn3 = XtCreateManagedWidget( "kanji1", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn3, XtNcallback, kanji1BtnProc, NULL);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  itemBtn1 = XtCreateManagedWidget( "kanji2", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x5021);

  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn2 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "prev", commandWidgetClass,
					form, args,  num);
  XtAddCallback( itemBtn2, XtNcallback, kigouPrevBtnProc, NULL );
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn3 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  itemBtn3 = XtCreateManagedWidget( "next", commandWidgetClass,
					form, args,  num);
  XtAddCallback( itemBtn3, XtNcallback, kigouNextBtnProc, NULL );

  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  closeBtn = XtCreateManagedWidget( "close", commandWidgetClass,
				     form, args,  num);
  XtAddCallback( closeBtn, XtNcallback, jisMenuCloseBtnProc, NULL );
}

void	NnmCreateKanji1Menu( Widget top )
{
  Arg		args[10];
  int		num;
  Widget        itemBtn1,itemBtn2, itemBtn3, closeBtn,form;

  kanji1MenuShell = XtCreatePopupShell( "kanji1menu",
				      overrideShellWidgetClass,
				      top, NULL, 0 );
  form = XtCreateManagedWidget( "kanji1form", formWidgetClass,
				   kanji1MenuShell, NULL, 0 );


  num = 0;
  itemBtn1 = XtCreateManagedWidget( "a-ka", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x3021);
  num = 0;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "ka-ke", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn2, XtNcallback, jisMenuProc, (XtPointer)0x3421);
  num = 0;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  itemBtn3 = XtCreateManagedWidget( "ke-ji", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn3, XtNcallback, jisMenuProc, (XtPointer)0x3821);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  itemBtn1 = XtCreateManagedWidget( "ji-su", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x3c21);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn2 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "su-chi", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn2, XtNcallback, jisMenuProc, (XtPointer)0x4021);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn3 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  itemBtn3 = XtCreateManagedWidget( "chi-ha", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn3, XtNcallback, jisMenuProc, (XtPointer)0x4421);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  itemBtn1 = XtCreateManagedWidget( "ha-ma", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn1, XtNcallback, jisMenuProc, (XtPointer)0x4821);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn2 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn3 = itemBtn2 = XtCreateManagedWidget( "ma-wa", commandWidgetClass,
				     form, args, num);
  XtAddCallback( itemBtn2, XtNcallback, jisMenuProc, (XtPointer)0x4c21);
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn1 ); num++;
  itemBtn1 = XtCreateManagedWidget( "prev", commandWidgetClass,
					form, args,  num);
  XtAddCallback( itemBtn1, XtNcallback, kigouPrevBtnProc, NULL );
  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn2 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn1 ); num++;
  itemBtn2 = XtCreateManagedWidget( "next", commandWidgetClass,
					form, args,  num);
  XtAddCallback( itemBtn2, XtNcallback, kigouNextBtnProc, NULL );

  num = 0;
  XtSetArg( args[num], XtNfromVert, itemBtn3 ); num++;
  XtSetArg( args[num], XtNfromHoriz, itemBtn2 ); num++;
  closeBtn = XtCreateManagedWidget( "close", commandWidgetClass,
				     form, args,  num);
  XtAddCallback( closeBtn, XtNcallback, kanji1CloseBtnProc, NULL );
}

void	NnmCreateJISPopup( Widget top )
{
  Arg		args[10];
  int		i, num;
  Widget        bsBtn,closeBtn;

  jisPopShell = XtCreatePopupShell( "jisshell",
				      overrideShellWidgetClass,
				      top, NULL, 0 );
  jisForm = XtCreateManagedWidget( "jisform", formWidgetClass,
				   jisPopShell, NULL, 0 );

  num = 0;
  jisCodeLabel = XtCreateManagedWidget( "label", labelWidgetClass,
					jisForm, args, num );

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisCodeLabel ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  XtSetArg( args[num], XtNborderWidth, 1 ); num++;
  XtSetArg( args[num], XtNinternational, True ); num++;
  
  for( i = 0; i < 16; i++ ){
    char tmp[2048];
    char *table[] = { "0", "1", "2", "3", "4", "5", "6", "7",
		      "8", "9", "A", "B", "C", "D", "E", "F" };    

    sprintf( tmp, "%s", table[i]);
    jisNumBtns[i] = XtCreateManagedWidget( tmp, commandWidgetClass,
					jisForm, args, num );

    XtAddCallback( jisNumBtns[i], XtNcallback, jisNumBtnProc,
		   (XtPointer) i);
    
    
    if((i & 0x3) == 3){
      XtSetArg( args[0], XtNfromVert, jisNumBtns[ i & 0x0c] );
      XtSetArg( args[1], XtNfromHoriz, NULL );
    }
    else{
      XtSetArg( args[1], XtNfromHoriz, jisNumBtns[i] );
    }
  }

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisNumBtns[12] ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  bsBtn = XtCreateManagedWidget( "bs", commandWidgetClass,
				     jisForm, args, num);
  
  XtAddCallback( bsBtn, XtNcallback, jisBSBtnProc, NULL);

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisNumBtns[12] ); num++;
  XtSetArg( args[num], XtNfromHoriz, bsBtn ); num++;
  closeBtn = XtCreateManagedWidget( "close", commandWidgetClass,
				     jisForm, args,  num);
  XtAddCallback( closeBtn, XtNcallback, jisCloseBtnProc, NULL );

}

void   kigouIdxBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg args[10];
  int x, y, width, height;
  int wx, wy;

  x = 0, y = 0, width = 0, height = 0;
  wx = 0, wy = 0;

  NnmGetWindowPos(jisCodeBtn, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouCommandForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetShellPos(&x, &y, &width, &height);
  wx += x, wy += y;

  XtSetArg( args[0], XtNx, wx );
  XtSetArg( args[1], XtNy, wy );
  XtSetValues( jisMenuShell, args, 2 );

  XtPopup(jisMenuShell, XtGrabNone );
}

void   jisCodeBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg args[10];
  int x, y, width, height;
  int wx, wy;

  x = 0, y = 0, width = 0, height = 0;
  wx = 0, wy = 0;

  NnmGetWindowPos(w, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouCommandForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetShellPos(&x, &y, &width, &height);
  wx += x, wy += y;

  currentCode = 0;
  NnmSetJisCodeLabelLabel(currentCode);

  XtSetArg( args[0], XtNx, wx );
  XtSetArg( args[1], XtNy, wy );
  XtSetValues( jisPopShell, args, 2 );

  XtPopup(jisPopShell, XtGrabNonexclusive );
}

Widget	CreateKigouWidgets( char *name, Widget parent, 
			      Arg cargs[], int num )
{
  Arg		args[10];
  int		i, j;
  Widget        kigouNextBtn, kigouPrevBtn, kigouIdxBtn;
  Widget        listForm, commandForm;
  char          s[256];

  kigouForm = XtCreateManagedWidget( name, formWidgetClass,
				     parent, cargs, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  listForm = XtCreateManagedWidget( "listform", formWidgetClass,
				     kigouForm, args, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  commandForm = XtCreateManagedWidget( "commandform", formWidgetClass,
				     kigouForm, args, num );
  kigouCommandForm = commandForm;

  kigouPage = 0x20;
  for( i = j = 0; i < KIGOU_DISP_MAX; i++,j++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + j) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + j) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];    
  }
  kigou_list[KIGOU_DISP_MAX] = NULL;

  i = 0;
  XtSetArg( args[i], XtNdefaultColumns, KIGOU_COLUMN); i++;  
  XtSetArg( args[i], XtNlabel, "list" ); i++;
  XtSetArg( args[i], XtNlist, kigou_list ); i++;
  kigouList = XtCreateManagedWidget( "list", listWidgetClass,
				   listForm, args, i );
  XtAddCallback( kigouList, XtNcallback, kigouListProc, NULL );

  i = 0;
  sprintf(s, "%04x", kigouPage + KIGOU_START);
  XtSetArg( args[i], XtNlabel, s); i++; 
  jisCodeBtn = XtCreateManagedWidget( "code", commandWidgetClass,
				       commandForm, args,  i);
  XtAddCallback( jisCodeBtn, XtNcallback, jisCodeBtnProc, NULL );
  
  i = 0;
  kigouPrevBtn = XtCreateManagedWidget( "prev", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouPrevBtn, XtNcallback, kigouPrevBtnProc, NULL );

  i = 0;
  kigouNextBtn = XtCreateManagedWidget( "next", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouNextBtn, XtNcallback, kigouNextBtnProc, NULL );

  i = 0;
  kigouIdxBtn = XtCreateManagedWidget( "idx", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouIdxBtn, XtNcallback, kigouIdxBtnProc, NULL );

  i = 0;
  kigouRETBtn = XtCreateManagedWidget( "return", commandWidgetClass,
				       commandForm, args,  i);
  XtAddCallback( kigouRETBtn, XtNcallback, kigouRETBtnProc, NULL );

  NnmCreateJISPopup(parent);
  NnmCreateJISMenu(parent);
  NnmCreateKanji1Menu(parent);
  return kigouForm; 
}
