/* 
   $Id: divide.c,v 1.1.1.1 2001/06/27 08:14:42 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <ctype.h>
#include "Nnm.h"
#include "NnmFeature.h"
#include "NnmProto.h"


static	void	Usage( argv0 )
     char	*argv0;
{
  fprintf( stderr, "Usage: %s <Sample File>\n",
	   argv0 );
  exit(1);
  
}


int	main( argc, argv )
     int	argc;
     char	**argv;
{
  int			i;
  ulong			code;
  int			sampfd;
  NnmRawCharInfoRec	charInfo;
  char			outfn[MAX_STR_LEN];
  
  
  /* Usage */
  if ( argc<=1 ){
    Usage( argv[0] );
  }

  for( i=1; i<argc; i++ ){
    if ( (sampfd=NnmFOpen( argv[i], "r" ))==-1 ){
      fprintf( stderr, "Cannot Open Sample Character File [%s]\n",
	       argv[i] );
      continue;
    }
    for( ; !NnmFEof(sampfd); ){
      NnmSampleReadFile( &charInfo, &code, sampfd );
      if ( code==0 ) continue;
      sprintf( outfn, "%04lX.sam", code );
      NnmSampleAppendFile( &charInfo, code, outfn );
    }
    NnmFClose( sampfd );
  }
  return 0;
}
